/*
 * PIHELPBU.C  Version Nov 2002 for unix only
 *
 * Purpose: Prints out brief help information interactively.
 *          This program PIHELPBU is called by PI to give
 *          online brief help information at run time. It
 *          can be run stand-alone as well. To work with PI
 *          the EXE should be named PIHELPBU.
 *
 * To compile, assemble pihelpbu.c using unix cc.
 *
 * cc -o pihelpbu pihelpbu.c
 *
 */

#include <stdio.h>
#define size(p) (sizeof(p)/sizeof(p[0]))
static
char *hlp[]={
"  *==[Function Keys]==*==[Basic Cursor Moves]==*==========[Other Keys]=======*",
"  | Key tutor      ^Oh| Left          LeftArrow| Delete char right       DEL ",
"  | Manual        ^O^H| Right        RightArrow| Delete char left        BS  |",
"  | Insert Line     ^N| Up              UpArrow| Copy chars to history  ^O^C |",
"  | Delete Line     ^D| Down          DownArrow| Inject history string  ^O^V |",
"  | Search setup    ^F| Page up            PgUp| Word Wrap toggle       ^O^W |",
"  | Search next     F5| Page Down          PgDn| Auto Indent toggle     ^O^I |",
"  | Search previous F6| Edge Left          HOME| Insert mode             INS |",
"  | Query Replace   ^H| Edge Right          END| Set Tab and margin     ^O^T |",
"  | Copy Line       F9| Edge Bottom        ^END| Toggle detab modes     ^O^D |",
"  | Paste Line     F10| Edge Top          ^HOME| Toggle hanging indent  ^O^U |",
"  | Line Ahead   ^Down| End of File        ^END| Split line at cursor   ^O^N |",
"  | Line Back      ^Up| Top of File       ^HOME| Bookmark set/goto ^K0 / ^Q0 |",
"  | Delete word   ^Del|===[File  Operations]===| Goto line prompt       ^O^G |",
"  | Delete to end ^Q^T| Next File            ^L| Justify text to margins  ^P |",
"  | Next word   ^Right| Select File (list) ^K^A| Center line            ^O,c |",
"  | Prev word    ^Left| Save & Exit        ^K^X| Copy line to NotePad   ^O^A |",
"  | Word to upper ^O,U| Save & Scrap       ^K^D| Move line to NotePad   ^O^K |",
"  | Word to lower ^O,L| Save As ...        ^K^W| Control codes: ^X then char |",
"  | Word capital  ^O,C| Save File (backup) ^K^S|=============================|",
"  | Record keys     F8| Close File         ^K^Q|ENTER Key:      Keypad Enter |",
"  | Replay keys     F7| Inject File        ^K^R|Quit:             Alt-X,^K^Z |",
"  | Suspend PI    ^U^U| Rename File        ^K^N|Menu:     Keypad 5, four ESC |",
"  *===================*========================*=============================*",
"    [KEYPAD Definitions]             [ESCAPE KEYPAD MOVES]",
"  *=======*",
"  |  Esc  |",
"  |[ENTER]|",
"  *=======*=======*======*=======*  *======*=======*======*",
"  |   7   |   8   |  9   |       |  |      |   8   | top  |",
"  |Left   |  Up   |Page  |       |  |      |search |  of  |",
"  |Edge   | Char  | up   |       |  |      |str Up | file |",
"  *=======*=======*======*=======*  *======*=======*======*",
"  |    4  |       |  6   |       |  |  4   |   5   |  6   |",
"  |  Left | Menu  |Right |       |  |delete|       |grab  |",
"  |  char |       |char  |       |  |char  |       |char  |",
"  *=======*=======*======*=======*  *======*=======*======*",
"  |   1   |  2    |  3   |       |  |Grab  |   2   |bottom|",
"  |Right  | Down  |Page  |       |  |word  |search |  of  |",
"  |Edge   | Char  | down |ENTER  |  |token |str Dn | file |",
"  *===========*==========| KEY   |  *======*=======*======*",
"  | 0         |   .      |       |[Press ESC twice, then the key]",
"  |    Insert |Delete    |       |",
"  |    Toggle |Char Rt   |       |",
"  *===========*==========*=======*",
"",
"                      [101 KEYBOARD FUNCTION KEYS]",
"       *======*======*======*======*======*======*======*======*======*======*",
"       |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |  F7  |  F8  |  F9  |  F10 |",
"Normal |      |      |      |      |Search|Search|Run   |Record|Copy  |Paste |",
"       |      |      |      |      |ahead |back  |macro |macro |line  |line  |",
"       *======*======*======*======*======*======*======*======*======*======*",
"",
"       *======*======*======*======*======*======*======*======*======*======*",
"       |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |  F7  |  F8  |  F9  |  F10 |",
"Ctrl   |      |      |      |      |      |      |      |      |      |Paste |",
"       |      |      |      |      |      |      |      |      |      |token |",
"       *======*======*======*======*======*======*======*======*======*======*",
"",
"       *======*======*======*======*======*======*======*======*======*======*",
"       |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |  F7  |  F8  |  F9  |  F10 |",
"Shift  |      |      |      |      |      |      |      |      |      |      |",
"       |      |      |      |      |      |      |      |      |      |      |",
"       *======*======*======*======*======*======*======*======*======*======*",
"",
"",
"",
"",
"",
"",
"            [WORDSTAR LAYOUT FOR STANDARD QWERTY KEYBOARDS]",
"",
"*======*======*======*======*======*======*======*======*======*======*",
"| Q    | W    |  E   |  R   |  T   |  Y   | U    | I    |  O   |  P   |",
"|Quick |line  |up    |prev  |erase |delete|abort |tab   |Option|ctrl  |",
"|prefix|up    |arrow |screen|word  |line  |key   |right |prefix|insert|",
"*======*======*======*======*======*======*======*======*======*======*",
"  | A    | S    |  D   |  F   |  G   |  H   |  J   |   K  |  L    |",
"  |left  |left  |right |right |delete|delete|Split+|File  | switch|",
"  |word  |arrow |arrow |word  |right |left  |Return|prefix| buffer|",
"  *======*======*======*======*======*======*======*======*=======*",
"    | Z    | X    |  C   |  V   | B    | N    |  M   |",
"    |line  |down  |next  |insert|reform|insert|next  |",
"    |down  |arrow |screen|toggle|lines |line  |line  |",
"    *======*======*======*======*======*======*======",
"",
"",
" Wordstar keys are executed by holding down [ctrl], then press the key",
"                   or keys required for the sequence.",
"",
"          For more help, press four ESC keys in the editor.",
"",
"",
""
};

void clrscr()
{
 printf("\033[H\033[2J");
}

int getch(){
char s[128]; char *ss;
  ss=fgets(s,127,stdin);
  return ss[0]; /* 2021 edit */
}



int main() {
int i,j,k;
  for(k=j=0;j<size(hlp)/24;++j){
    clrscr();
    for(i=0;i<24;++i) printf("%s\n",hlp[k++]);
    printf("Press [RETURN] to continue, [Q] to quit: ");
    switch(getch()){
    case 'Q':
    case 'q':
    case 'S':
    case 's':
    case 'E':
    case 'e':
    case 3: goto quit;
    }
  }
quit:
 return 0;
}
